#!/usr/bin/perl
#################################################################
#FILE: dparser.pm
#TEXT DATA PARSING MODULE
#Copyright  by UrsaloFF 
#################################################################
use CGI;
package dparser;
$qq=new CGI;
$VERSION='1.1';
sub new {
	my $classname=shift;
	my $self = {};
	bless ($self,$classname);
	$self->_init(@_);
	return $self;
}
#############################################
sub _init{
	my $self=shift;
	###DEFAULT###
	$self->_set_defaults;
	###INIT_DATA - OVERVRITE DEFAULTS
	if (@_){
		my %extra= @_;
		foreach (keys %extra){
			$self->{$_}=$extra{$_};
		}
	}
	#####LOAD DATA FROM SOURCE
	$self->_load_data;

	###ADDITIONAL PARSING

}
######
sub _set_defaults{
	my $self=shift;
	$self->{SOURCE}='file';
	$self->{STRING_DELMITTER}="\r\n";
}
######
sub _load_data{
	my $self=shift;
	if ($self->{'SOURCE'}=~/^file/i){
		#$self->{'DATA'}=~s/\.html$/.dat/;
		open(FILE,$self->{'DATA'}) || die "DataParser::Can not load data from FILE $self->{'DATA'} - $!";
		$\="";
		my  $DATA;#=<FILE>;
		while(<FILE>){
			$DATA.=$_;
		}
		my @DATA=loaddata($DATA);
		chomp(@DATA);
		$self->{ALL_DATA_ARRAY}=\@DATA;
		close(FILE);
	}elsif(($self->{'SOURCE'}=~/^handle/i)){
		my $handle=$self->{DATA};
		my  @DATA=<$handle>;
		chomp(@DATA);
		$self->{ALL_DATA_ARRAY}=\@DATA;
	}elsif(($self->{'SOURCE'}=~/^string/i)){
		my @DATA=split /\n/,$self->{DATA};
		chomp(@DATA);
		$self->{ALL_DATA_ARRAY}=\@DATA;
	}elsif(($self->{'SOURCE'}=~/^array_ref/i)){
		$self->{ALL_DATA_ARRAY}=$self->{DATA};
	}else{
		die "DataParser: Can not understand the SOURCE value it must be  file|handle|string|array_ref";
	}

}
##################
sub loaddata{
	my $what=shift;
	#$what=~tr/abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789/DNfeQS5Ouj6rMkIg9PwTXHzC1Vc3vEA8nxlLF7KYbsUmJhZ4WoRqiGpy0aBd2t/;
	#$what =~ s/_([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;
	my @what=split(/\n/,$what); #@what=map{$_."\n"}@what;
	return @what;
}
######  CutArray
sub SplitData{
	my $self=shift;
	my $befor=shift;
	my $after=shift;
	$self->{BEFOR_ARRAY}=[];
	$self->{AFTER_ARRAY}=[];
	$self->{INSIDE_ARRAY}=[];
	my $status='befor';  # 'befor', 'after', 'in'
	foreach(@{$self->{ALL_DATA_ARRAY}}){
		if(/(.*)$befor(.*)/ && $status eq 'befor'){
			push(@{$self->{BEFOR_ARRAY}},$1);
			push(@{$self->{INSIDE_ARRAY}},$2);
			$status='in';
			next;
		}
		if(/(.*)$after(.*)/ && $status eq 'in'){
			push(@{$self->{INSIDE_ARRAY}},$1);
			push(@{$self->{AFTER_ARRAY}},$2);
			$status='after';
			next;
		}
		if ($status eq 'befor'){
			push(@{$self->{BEFOR_ARRAY}},$_);
		}elsif($status eq 'after'){
			push(@{$self->{AFTER_ARRAY}},$_);
		}else{##status eq 'in'
			push(@{$self->{INSIDE_ARRAY}},$_);
		}

	}
}
sub getBEFORE{
	my $self=shift;
	return @{$self->{BEFOR_ARRAY}};
}
sub getAFTER{
	my $self=shift;
	return @{$self->{AFTER_ARRAY}};
}
sub getINSIDE{
	my $self=shift;
	return @{$self->{INSIDE_ARRAY}};
}

sub deleteBEFORE_AFTER{
	my $self=shift;
	$self->{ALL_DATA_ARRAY}=$self->{INSIDE_ARRAY};
}
sub replaceINSIDE{
	my $self=shift;
	my $what=shift;
	#$funk is a funnction ref
	my @data=($self->getBEFORE,$what,$self->getAFTER);
	$self->{ALL_DATA_ARRAY}=\@data;
}
sub deleteINSIDE{
	my $self=shift;
	#$funk is a funnction ref
	my @data=($self->getBEFORE,$self->getAFTER);
	$self->{ALL_DATA_ARRAY}=\@data;
}
sub add_regesp{
	my $self=shift;
	my $patten=shift;
	my $replace=shift;
	$self->{REGESP}{$patten}=$replace if $patten;
}
#######
sub add_func{
	my $self=shift;
	my $patten=shift;
	my $replace=shift;
	$self->{FUNC}{$patten}{f_ref}=$replace if $patten;
	$self->{FUNC}{$patten}{args}=[@_] if $patten;
}
#######
sub add_parsing{
	my $self=shift;
	my $func_ref=shift;
	push(@{$self->{PARSING}},$func_ref);
}
sub loadCSS{
	open (DATACSS,"shabl/style.css") || die "Can not open file: shabl/style.css";
	my @css=<DATACSS>;
	close(DATACSS);
	return join("",@css);
}
#####################################
sub ChangeData{
###CHANGING TEMPLATE BEFOR PARSING
	my $self=shift;
	my $patten = shift;
	my $replace= shift;
	return unless $patten;
	foreach(@{$self->{ALL_DATA_ARRAY}}){
		s/$patten/$replace/g
	}
}
########
sub ParseData{
	my $self=shift;
	my @OUT;
#FOR THIS PROJECT ONLY
	$self->add_regesp('{ME}',$ENV{SCRIPT_NAME});
	$self->add_func('{CSS}',\&loadCSS);
	$self->add_regesp('{ses}',$qq->param("ses"));
	$self->SplitData('<!--hide-->','<!--endhide-->');
	$self->replaceINSIDE();
###############
	my %regesp=%{$self->{REGESP}};
	my %functions=%{$self->{FUNC}};
	my @parsing=@{$self->{PARSING}};
	foreach(@{$self->{ALL_DATA_ARRAY}}){
		##Replace data from {REGESP};
		foreach my $reg (keys %regesp){
			s/$reg/$regesp{$reg}/g
		}
		##Replace data from function {FUNC}
		foreach my $funk (keys %functions){
			if (s/(.*)$funk(.*)//){
				my $ret=$functions{$funk}{f_ref};
				my @args=@{$functions{$funk}{args}};
				$_="$1".&$ret(@args)."$2";
				###first param of all functions - $self
			}
		}
		# if defined {PARSING}
		foreach my $parse (@parsing){
			&$parse($self);
		}

	}####end foreach for all lines
}
######
sub ForeachString{
	my $self=shift;
	my $funk=shift;
	my @OUT;
	foreach(@{$self->{ALL_DATA_ARRAY}}){
		&$funk;
	}
}
######
sub as_array{
	my $self=shift;
	return $self->ProcessArray($self->{ALL_DATA_ARRAY});
}
######
sub get {
	my $self = shift;
	my $what=shift;
	return $self->{$what};
}
##################
sub as_string {
	my $out;
	my $self = shift;
	$out=join($self->{STRING_DELMITTER},@{$self->{ALL_DATA_ARRAY}});
	return $out;
}
###########################
sub print{
	my $self = shift;
	print $self->as_string;
}
1;
###########################



